<template>
  <div id="app">
    <div class="mb-5">
      <!-- <app-collection
        ref="appCollection"
        url="https://jsonplaceholder.typicode.com/comments?postId="
        loading_image="https://cdn4.iconfinder.com/data/icons/pictype-free-vector-icons/16/spinner-512.png"
        count="1"
        method="GET"
        sort_key="body"
        load_more_type="loadMoreButton"
        filter_key="id"
        filter_value="5"
        @success="on_success($event)"
        @failure="on_failure($event)"
      >
        <template
          v-slot:body="{ item }"
          class="item"
        >
          <card :item="item"/>
        </template>

        <template
          v-slot:load_more_button
        >
          <b-button
            @click="$refs.appCollection.set_ajax()"
          >
            More
          </b-button>
        </template>
      </app-collection> -->

      <app-collection-grouped
        ref="appCollectionGrouped"
        url="https://jsonplaceholder.typicode.com/comments?postId="
        loading_image="https://cdn4.iconfinder.com/data/icons/pictype-free-vector-icons/16/spinner-512.png"
        count="1"
        method="GET"
        sort_key="body"
        load_more_type="loadMoreButton"
        filter_key="id"
        filter_value="5"
        group_key="postId"
        @success="on_success($event)"
        @failure="on_failure($event)"
      >
        <template
          v-slot:group_header="{ title }"
        >
          <h2>{{ title }}</h2>
        </template>

        <template
          v-slot:body="{ item }"
          class="item"
        >
          <card :item="item"/>
        </template>

        <template
          v-slot:group_footer
        >
          Footer
        </template>

        <template
          v-slot:load_more_button
        >
          <b-button
            @click="$refs.appCollectionGrouped.set_ajax()"
          >
            More
          </b-button>
        </template>
      </app-collection-grouped>
    </div>
  </div>
</template>

<script>
import { AppCollection, AppCollectionGrouped } from '../../components'
import Card from './Card.vue'

export default {
  name: 'app',

  components: {
    AppCollection,
    AppCollectionGrouped,
    Card,
  },

  mounted() {
    // this.$refs.appCollection.set_ajax()
    this.$refs.appCollectionGrouped.set_ajax()
  },

  methods: {
    on_success(data) {
      // success event exapmle
      console.log('success', data)
    },

    on_failure(response) {
      // failure event exapmle
      console.log('failure', response)
    },
  },
}
</script>
